#include "B4RDefines.h"
namespace B4R {
	void STM32_WireMaster::Initialize() {
		buffer.data = bufferData;
		Wire.begin();
	}
	ArrayByte* STM32_WireMaster::RequestFrom(Byte Address, Byte Length) {
		Byte len = Wire.requestFrom(Address, Length);
		for (byte i = 0;i < len;i++)
			((Byte*)buffer.data)[i] = Wire.read();
		buffer.length = len;
		return &buffer;
	}
	Byte STM32_WireMaster::WriteTo2(Byte Address, bool SendStop, ArrayByte* Data) {
		Wire.beginTransmission(Address);
		byte b = Data->length;
		Wire.write((Byte*)Data->data, Data->length);
		//the following change was made by B4X user "derez" on 16/Oct/17
		//if (SendStop) {
		//	Wire.i2c_stop();
		//}
		//Wire.endTransmission();
        Wire.endTransmission(SendStop);  //and this line added
        return b;
	}
	Byte STM32_WireMaster::WriteTo(Byte Address, ArrayByte* Data) {
		return WriteTo2(Address, true, Data);
	}
	bool STM32_WireMaster::IsConnected(Byte Address) {
	    Wire.beginTransmission(Address);
		byte error = Wire.endTransmission();
		return (error == 0);
	}
}