#pragma once
#include "B4RDefines.h"
//~dependson: <Wire.h>
namespace B4R {
	//~Version: 1.11
	//~shortname: STM32_WireMaster
	#define WIRE_MAX_SIZE 32
	class STM32_WireMaster {
		private:
			Byte bufferData[WIRE_MAX_SIZE];
			ArrayByte buffer;
		public:
			//Initializes the WireMaster object.
			void Initialize();
			//Requests data from a slave and returns it as an array of bytes.
			//This will return the data prepared by the slave with the call to SetDataForMater.
			//Note that the returned array length might be smaller than the requested length.
			//Address - Slave address.
			//Length - Number of bytes requested.
			ArrayByte* RequestFrom(Byte Address, Byte Length);
			//Sends the given array to the slave.
			Byte WriteTo(Byte Address, ArrayByte* Data);
			//Similar to WriteTo.
			//SendStop - Whether to send a stop at the end (default is true).
			Byte WriteTo2(Byte Address, bool SendStop, ArrayByte* Data);
			//test if Slave Address is connected
			bool IsConnected(Byte Address);
			};
	typedef Array* (*SubArrayVoid)(void) ;
	
	
}